package com.hrsk.cloud.eg.client.vo;

import lombok.Data;

import java.io.Serializable;

/**
 * @author zhangyy
 * @version 1.0
 * @description: OrderResponseVo
 * @date 2024/11/16 12:11
 */
@Data
public class OrderResponseVo implements Serializable {
    //0 成功 1 失败
    private Integer code;

    //orderId
    private String orderId;

    //错误描述 或者成功的描述
    private String msg;

    //对应平台
    private String platform;

    public static OrderResponseVo ok(String orderId, String msg, String platform) {
        OrderResponseVo orderResponseVo = new OrderResponseVo();
        orderResponseVo.setCode(0);
        orderResponseVo.setOrderId(orderId);
        orderResponseVo.setMsg(msg);
        orderResponseVo.setPlatform(platform);
        return orderResponseVo;
    }
    public static OrderResponseVo ok( String platform) {
        OrderResponseVo orderResponseVo = new OrderResponseVo();
        orderResponseVo.setCode(0);
        orderResponseVo.setOrderId(null);
        orderResponseVo.setMsg(null);
        orderResponseVo.setPlatform(platform);
        return orderResponseVo;
    }

    public static OrderResponseVo fail(String msg, String platform) {
        OrderResponseVo orderResponseVo = new OrderResponseVo();
        orderResponseVo.setCode(1);
        orderResponseVo.setOrderId(null);
        orderResponseVo.setMsg(msg);
        orderResponseVo.setPlatform(platform);
        return orderResponseVo;
    }

}
