package com.hrsk.cloud.eg.domain.api;

import java.util.List;

/**
 * @author: bianlanzhou
 * @create: 2024-11-10 21:01
 * @description: API工厂
 **/
public class ApiFactory {
    /**
     * 创建API通道
     * @param apiCode
     */
    /**
     * 创建API通道
     * @param apiCode API编码
     * @param integrationMode 集成方式
     * @param requestConfigStr 请求配置
     * @param responseConfigStr 响应配置
     * @return
     */
    public static ApiChannel createApiChannel(String apiCode,String integrationMode,String requestConfigStr,String responseConfigStr){
        return new ApiChannel(apiCode,integrationMode,requestConfigStr,responseConfigStr);
    }

    /**
     * 创建API
     * @param apiChannels api通道
     * @return API
     */
    public static Api createApi(List<ApiChannel> apiChannels){
        return new Api(apiChannels);
    }
}
