package com.hrsk.cloud.eg.domain.api.channel.customized.threedocking;

import com.google.common.base.Function;
import com.hrsk.cloud.eg.client.dto.RedisSetDto;
import com.hrsk.cloud.eg.client.dto.plan.command.EgLoanApiConfigInfoCmd;
import com.hrsk.cloud.eg.client.dto.plan.command.PlanCmd;
import com.hrsk.cloud.eg.client.dto.user.command.UserBaseInfoCmd;
import com.hrsk.cloud.eg.client.vo.DataVo;
import com.hrsk.cloud.eg.domain.api.channel.customized.common.ServerCodeEnums;
import com.hrsk.cloud.eg.domain.api.channel.guide.http.HttpApiRequest;
import com.hrsk.cloud.eg.domain.api.channel.guide.http.HttpApiResponse;


/**
 * @author zhangyy
 * @version 1.0
 * @description: dockingApi 三方助贷对接
 * @date 2024/9/10 14:31
 */
public interface LoanDockingApi {

    /**
     * @description:  撞库接口
     * @param:
     * @return:
     * @author zhangyy
     * @date: 2024/9/10 14:33
     */
    DataVo qualityCheck(UserBaseInfoCmd user, PlanCmd planDto, EgLoanApiConfigInfoCmd configInfoCmd, Function<HttpApiRequest, HttpApiResponse> httpClientFunc,Function<String, Object> redisGetFunc,Function<RedisSetDto,Boolean> redisSetFunc);


    /**
     * @description: 对接类型
     * @param:
     * @return:
     * @author zhangyy
     * @date: 2024/9/10 14:33
     */
    ServerCodeEnums getType();

}
