package com.hrsk.cloud.eg.domain.api.channel.guide.func;

import com.google.common.collect.Lists;
import com.hrsk.cloud.eg.domain.api.ApiContext;
import com.hrsk.cloud.eg.domain.api.channel.guide.common.ValueObject;
import com.hrsk.cloud.eg.domain.api.channel.guide.resolver.vo.ValueObjectResolverManager;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;
import java.util.List;

/**
 * @author: bianlanzhou
 * @create: 2024-07-27 11:05
 * @description: 函数对象,值对象
 **/
@ToString
@Data
public class FunctionObject implements Serializable {
    /**
     * 编码
     */
    private String code;
    /**
     * 参数
     */
    private List<ValueObject> args = Lists.newArrayList();

    /**
     * 执行
     * @param value 值对象
     * @param apiContext 上下文
     * @return 结果
     */
    public Object apply(Object value, ApiContext apiContext){
        FunctionParam functionParam = new FunctionParam().setInput(value);
        for(ValueObject arg : args){
            functionParam.getExtArg().add(ValueObjectResolverManager.getInstance().resolve(arg,apiContext));
        }
        return ValueObjectFunctionManager.getInstance().apply(code,functionParam);
    }


}
