package com.hrsk.cloud.eg.domain.api.route.strategy;

import com.hrsk.cloud.eg.client.dto.cmd.RouteCmd;
import com.hrsk.cloud.eg.domain.api.ApiChannel;
import org.apache.commons.lang3.StringUtils;
import org.springframework.util.CollectionUtils;

import java.util.List;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * @author: bianlanzhou
 * @create: 2024-11-10 17:26
 * @description: API通道编码路由策略 这是一个过滤路由
 **/
public class ChannelCodeBasedRouteStrategy implements RouteStrategy{

    @Override
    public boolean route(List<ApiChannel> apiChannels, RouteCmd route){
        if(StringUtils.isEmpty(route.getCode())){
            return true;
        }
        apiChannels = apiChannels.stream().filter(new Predicate<ApiChannel>() {
            @Override
            public boolean test(ApiChannel apiChannel) {
                return StringUtils.equals(apiChannel.getChannelCode(),route.getCode());
            }
        }).collect(Collectors.toList());
        if(CollectionUtils.isEmpty(apiChannels)){
            return false;
        }
        return true;
    }
}
