package com.hrsk.cloud.eg.domain.common;

import com.google.gson.Gson;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import org.apache.commons.lang3.StringUtils;

import java.util.regex.Pattern;

/**
 * @author: bianlanzhou
 * @create: 2024-08-01 16:58
 * @description: Gson工具类
 **/
public class GsonUtils {
    /**
     * gson
     */
    public static final Gson GSON = new Gson();
    /**
     * 转换JSON
     * @return 实体
     * @param <T> 范型
     */
    public static <T> T fromJson(String json,Class<T> classz){
        return GSON.fromJson(json,classz);
    }

    /**
     * 转换JSON
     * @return 实体
     * @param <T> 范型
     */
    public static <T> T fromJson(JsonElement json, Class<T> classz){
        return GSON.fromJson(json,classz);
    }


    /**
     * 转化JSON
     * @param object 参数
     * @return JSON
     */
    public static String toJson(Object object){
        return GSON.toJson(object);
    }

    /**
     * 转化json object
     * @param object
     * @return
     */
    public static JsonObject toJsonObject(Object object){
        String json = GSON.toJson(object);
        return GSON.fromJson(json, JsonObject.class);
    }

    /**
     * json类型推测，判断是否是json
     * @param str
     * @return
     */
    public static boolean isJson(String str){
        if(StringUtils.isEmpty(str)){
            return false;
        }
        Pattern pattern = Pattern.compile(Constants.REGEX_JSON_PATH);
        return pattern.matcher(str).matches();
    }
}
