package com.hrsk.cloud.eg.domain.common;

import com.google.common.collect.Lists;
import com.hrsk.cloud.eg.domain.api.channel.guide.common.KeyValueObject;
import com.hrsk.cloud.eg.domain.api.channel.guide.common.ValueObjectTypeEnum;
import org.apache.commons.lang3.StringUtils;

import java.util.List;

/**
 * @Author Liu Tao
 * @Date 2024 11 21 15 18
 **/
public class HeadsUtil {

    public static List<KeyValueObject> getJsonHeaders(String key,String value) {
        List<KeyValueObject> headers = Lists.newArrayList();

        KeyValueObject head = new KeyValueObject();
        head.setType(ValueObjectTypeEnum.BASIC.getType());
        head.setKey("Content-Type");
        head.setValue("application/json");
        headers.add(head);
        if (StringUtils.isNotBlank(key)&&StringUtils.isNotBlank(value)){
            KeyValueObject head2 = new KeyValueObject();
            head2.setType(ValueObjectTypeEnum.BASIC.getType());
            head2.setKey("Content-Type");
            head2.setValue("application/json");
            headers.add(head2);
        }
        return headers;
    }

    public static List<KeyValueObject> getFromHeaders(String key,String value) {
        List<KeyValueObject> headers = Lists.newArrayList();

        KeyValueObject head = new KeyValueObject();
        head.setType(ValueObjectTypeEnum.BASIC.getType());
        head.setKey("Content-Type");
        head.setValue("application/x-www-form-urlencoded; charset=UTF-8");
        headers.add(head);
        if (StringUtils.isNotBlank(key)&&StringUtils.isNotBlank(value)){
            KeyValueObject head2 = new KeyValueObject();
            head2.setType(ValueObjectTypeEnum.BASIC.getType());
            head2.setKey("Content-Type");
            head2.setValue("application/json");
            headers.add(head2);
        }
        return headers;
    }
}
