package com.hrsk.cloud.eg.domain.common.constant;

/**
 * @author: bianlanzhou
 * @create: 2024-11-12 18:15
 * @description: 系统错误编码枚举
 **/
public enum SysErrorCodeEnum {
    BEETL_ERROR("100001","模版渲染失败!");
    private String code;

    private String message;
    /**
     * 前缀
     */
    private static final String PREFIX = "sys-";

    /**
     * 构造函数
     * @param code 编码
     * @param message 描述消息
     */
    SysErrorCodeEnum(String code, String message) {
        this.code = code;
        this.message = message;
    }

    /**
     * 获取编码
     * @return 编码
     */
    public String getCode() {
        return PREFIX + code;
    }

    /**
     * 获取消息
     * @return 返回消息
     */
    public String getMessage() {
        return message;
    }

}
