package com.hrsk.cloud.eg.infrastructure.client.http;

import com.hrsk.cloud.eg.domain.api.channel.guide.http.HttpApiRequest;
import com.hrsk.cloud.eg.infrastructure.common.InfrastructureException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import javax.annotation.Resource;
import java.util.Objects;

/**
 * @author: bianlanzhou
 * @create: 2024-09-06 11:14
 * @description: HTTP请求客户端
 **/
@Slf4j
@Component
public class HttpClient {
    @Resource
    private RetryRestTemplate restTemplate;
    /**
     * 数据交换
     * @param request 请求
     * @return response 响应
     */
    public ResponseEntity<String> exchange(HttpApiRequest request){
        ResponseEntity<String> responseEntity = null;
        try {
            return restTemplate.restTemplate().exchange(request.getUrl(),
                    Objects.requireNonNull(HttpMethod.resolve(request.getMethod())),
                    new HttpEntity<>(request.getPayload()),
                    String.class);
        } catch (Exception e) {
            log.error("请求异常,请求数据:[{}].", request.toString() ,e);
            throw new InfrastructureException("请求异常!",e);
        }
    }
}
