package com.hrsk.cloud.eg;


import lombok.extern.slf4j.Slf4j;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.util.StopWatch;

@Slf4j
@SpringBootApplication
@MapperScan("com.hrsk.cloud.eg.infrastructure.repository.database")
public class Application {
    /**
     * main函数
     * @param args 参数
     */
    public static void main(String[] args) {
        launch(args);
    }

    /**
     * 引导方法
     * @param args 参数
     */
    private static void launch(String[] args){
        log.info("Begin to start Spring Boot Application ......");
        StopWatch stopWatch = new StopWatch();
        stopWatch.start();
        SpringApplication.run(Application.class, args);
        stopWatch.stop();
        log.info("Spring Boot Application has been started, Time used: {} ms .",stopWatch.getTotalTimeMillis());
    }
}
